﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr150_2
{
    // Базовый класс: 
    class Alpha
    {
        // Целочисленное поле: 
        public int ch1;
        // Виртуальный целочисленный индексатор 
        // с целочисленным индексом: 
        public virtual int this[int k]
        {
            // Аксессор для считывания значения: 
            get
            {
                // Сохраняем значение поля:
                int t = ch1;
                int kl = 0, ch = 0;
                // Отсчитываем с конца требуемую цифру:
                while (kl < k) {
                    kl++;
                    ch = t % 10;
                    t = t / 10;
                }
                // Возвращаем результат:
                return ch;
            }
        }
    }

    // Производный класс: 
    class Bravo : Alpha {
        // Целочисленное поле: 
        public int ch2;
        // Определение индексатора с двумя 
        // целочисленными индексами:
        public int this[int ch, int k]
        {
            // Аксессор для считывания значения: 
            get
            {
                // Определяем, из какого поля
                // берем значение:
                int t;
                if (ch == 1) t = base.ch1;
                else t = ch2;
                int kl = 0, c = 0;
                // Отсчитываем с конца требуемую цифру:
                while (kl < k) {
                    kl++;
                    c = t % 10;
                    t = t / 10;
                }
                // Возвращаем результат:
                return c;
            }
        }
        // Переопределение индексатора с целочисленным индексом: 
        public override int this[int k]
        {
            // Аксессор для считывания значения: 
            get
            {
                // Складываем значения полей:
                int t = base.ch1 + ch2;
                int kl = 0, ch = 0;
                // Отсчитываем с конца требуемую цифру:
                while (kl < k) {
                    kl++;
                    ch = t % 10;
                    t = t / 10;
                }
                // Возвращаем результат:
                return ch;
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создаем объект класса Alpha:
            Alpha A = new Alpha();
            // Определяем значение поля:
            A.ch1 = 87615;
            // Выводим значения поля и 
            // индексатора:
            Console.WriteLine("А.ch1 = " + A.ch1);
            Console.WriteLine("А[2] = " + A[2]);
            Console.WriteLine();
            // Создаем объект класса Bravo:
            Bravo B = new Bravo();
            // Определяем значения полей:
            B.ch2 = 23456;
            B.ch1 = 12345;
            // Выводим значения полей и 
            // индексаторов:
            Console.WriteLine("B.ch1 = " + B.ch1);
            Console.WriteLine("B.ch2 = " + B.ch2);
            Console.WriteLine("B[1, 4] = " + B[1, 4]);
            Console.WriteLine("B[2, 3] = " + B[2, 3]);
            Console.WriteLine();
            int s = B.ch1 + B.ch2;
            Console.WriteLine("B.ch1 + B.ch2 = " + s);
            Console.WriteLine("B[3] = " + B[3]);
            // Задержка:
            Console.ReadLine();
        }
    }
}
